<?php
#################################################################
#	DatabaseManager.php
#	Written by John Faller © 2004
#
#	Used to manage a connection to a MySQL database using ADODB
#################################################################

// Set adodb cache directory
require('adodb/adodb.inc.php');
$ADODB_CACHE_DIR = 'adodbcache';

class DatabaseManager {
	// Set MySQL Connection Variables
	var $_DB;
	var $_DB_Type = "mysql";
	var $_DB_Host = "localhost";
	var $_DB_User = "root";
	var $_DB_Pass = "";
	var $_DB_Name = "";
	var $_SQLResults = "";

	function DatabaseManager($strDatabase){
		// Open MySQL Connection
		$this->_DB_Name=$strDatabase;
		$this->_DB = &ADONewConnection($this->_DB_Type);
		$this->_DB->Connect($this->_DB_Host, $this->_DB_User, $this->_DB_Pass, $this->_DB_Name);
	}

	function ExecuteQuery($strQuery){
		//Execut Query - SELECT")
		$this->_SQLResults = $this->_DB->GetAll($strQuery);
		return $this->_SQLResults;
	}

	function ExecuteCacheQuery($strQuery){
		//Execut Cached Query - SELECT
		$this->_SQLResults = $this->_DB->CacheGetAll($strQuery);
		return $this->_SQLResults;
	}

	function ExecuteNonQuery($strQuery){
		//Execute Non Query - DELETE, UPDATE and INSERT	
		return $this->_DB->execute($strQuery); 
	}

	function GetLastInsertedID(){
		//Returns Last Inserted ID
		return $this->_DB->Insert_Id();
		}

	function GetRowCount(){
		//Returns row count
		return count($this->_SQLResults);
		}

	function GetResults(){
		//Returns results
		return $this->_SQLResults;
		}

	function GetRowAffected(){
		//Returns rows affected
		return $this->_DB->AffectedRows();
	}

	function Close(){
		//Closes connection
		$this->_DB->Close();
	}
}//End DatabaseManager
?>
