<?
/*
	22.10.2005 Version 1.03 Kevin Kempfer (mysnom@kevinkempfer.de)

	Script zum Anzeigen des aktuell verbleibende Guthabens jedes Providers im
	Display des Snom 190 IP-Telefons.
	Im Unterverzeichnis "modules" liegen die Module der einzelnen Provider.

	Dieses Script steht unter der GPL und darf daher frei verbreitet und benutzt
	werden. Ein Hinweis auf den Autor wird jedoch erbeten. Die GPL-Lizens kann
	hier eingesehen werden: http://www.gnu.org/copyleft/gpl.html

	Weitere Provider-Module knnen gern an mich gemailt werden und werden dann
	integriert.

	ANFORDERUNGEN:
	- PHP 4, Apache oder IIS, evtl. MySQL
	- SSL-Support fr PHP, die meisten Provider-Websites sind per SSL gesichert. Damit
	  PHP darauf zugreifen kann, muss SSL-Support aktiviert sein. Durch einen
	  Bug in PHP muss dieser nach meinem derzeitigen Kenntnisstand in PHP einkompiliert
	  sein und darf nicht als Extension geladen werden. Hilfreich dabei war fr mich
      http://ftp.emini.dk/pub/php/win32/openssl/ wo es fertig kompilierte PHP-Versionen
	  mit SSL-Support gibt.
	- falls gewnscht MySQL, derzeit wird hier nur die IP des Telefons gespeichert.
	  Kann auch in der Variable $SnomIP geschehen. Die Zugangsdaten
	  zum MySQL-Server mssen in "DatabaseManager.php" eingetragen werden.
	  SQL-Befehle zum Erstellen der Datenbank-Tabellen finden sich in snom.sql
	  MySQL-Support kann ber die Variable "useDB" abgeschalten werden.
	- In modules/sipgate.php mssen Benutzername und Passwort eingetragen werden

	UPDATES:
	Die jeweils aktuellste Version dieses Scripts findet sich unter
	http://www.bier-voting.de/mysnom/mysnom.zip

	TODO:
	Natrlich kann man einiges mit dem Webinterface des Telefons anstellen ;-)
	Ganz nett wre:
	- Installationsskript, das Benutzernamen/Passwrter etc. abfragt und in der DB speichert,
	  sodass kein manuelles Eingreifen in das Script ntig ist.
	- mehr Provider-Module
	- ??? (Vorschlge an mysnom@kevinkempfer.de)

	NDERUNGEN:
	Version 1.03 Die Abfrage kann auf einzelne Provider eingeschrnkt werden.
				 (z.B. auf die aktivierte Leitung des Telefons)
				 Dazu an die Action-URL den Parameter provider=<name> anhngen.
				 Der Name entspricht dem Dateinamen (ohne .php) der Moduldatei des Providers
	Version 1.02 Die Anzeigedauer des Kontostands kann angegeben werden
	Version 1.01 Zugriff auf das Telefon funktioniert jetzt auch mit HTTP BASIC Authentication
				 Benutzername und Passwort fr das Webinterface bitte in den Variablen $SnomUser
				 und $SnomPass ablegen.
	Version 1.0  Erste Verffentlichung
*/

require_once("classes/settings.php");

class Snom
{
	var $useDB = false; //auf true setzen, falls Datenbank gewnscht
	var $SnomUser = "";
	var $SnomPass = "";
	var $SnomIP; //Snom-IP kann hier fest gesetzt werden, dann kann das Script auch via Browser aufgerufen werden
	var $waitfor=3; // Die Anzahl Sekunden, die der Kontostand eingeblendet bleiben soll.
	//AB HIER NICHTS NDERN
	var $modules_directory = "modules";
	var $idletext;
    var $arrProviders;
	function Snom()
    {
		//Versuchen, die IP-Adresse des Snom aus der DB zu holen
		if($this->useDB)
        {
			$this->debug("Benutze Datenbank");
			$setting = new settings;
			$setting->LoadByKey("snom_ip");
			if($setting->Getvalue()!="")
			{	$this->SnomIP = $setting->Getvalue();
				$this->debug("IP des Telefons: ". $this->SnomIP);
			}

		}else{
			if(!$this->detectIP())
				$this->error(1);
		}

   		$this->readModules();
		
	}

/*
	Alle Provider-Klassen werden als Module nachgeladen, tragen den Provider-Namen als Namen
	und mssen die Funktionen getBalance()  und getServer()implementieren.
	getBalance() soll den aktuellen Kontostand zurckgeben
	getServer()  soll den Servernamen zurckgeben, der im Snom unter "Registrar"
				 gespeichert ist (fr die Zuordnung Provider<->Leitung)

*/

	function readModules($dir = "modules")
	{

		$dh  = opendir($dir);
		while ($filename = readdir($dh))
		{
		   if (!($filename=="." || $filename==".."))
		   {
				preg_match("/([a-z,A-Z,0-9]+).php/",$filename,$treffer);
				if(sizeof($treffer)>0)
                {
                    include_once($dir."/".$filename);
					$this->arrProviders[]=$treffer[1];
				}
		   }
		}
	print_r($this->arrProviders);
	}

	function detectIP()
    {
		if($_SERVER['REMOTE_ADDR']!="")
		{   $this->debug("IP des Telefons automatisch erkannt: ".$_SERVER['REMOTE_ADDR']);
			$this->SnomIP = $_SERVER['REMOTE_ADDR'];
			return true;
        }else{
			return false;
		}
	}

	function showSettings()
    {
		echo "<html><head><title>Snomulator</title></head><body>";
		echo "<form action=\"".$_SERVER['PHP_SELF']."\" method=\"get\">";
		echo "IP des Telefons: <input type=\"text\" size=\"15\" maxlength=\"15\" name=\"ip\" value=\"".$this->SnomIP."\">";
		echo "<br><input type=\"submit\" name=\"speichern\" value=\"speichern\">";
		echo "<input type=\"hidden\" name=\"action\" value=\"save\">";
		echo "</form>";
		echo "</body></html>";

	}

	function error($errCode)
	{
		switch($errCode)
        {
			case 1:
				//Keine IP des Telefons verfgbar
				die("Die IP-Adresse des Telefons ist unbekannt!");
				break;
			case 2:
				//unbekannter Provider oder falsche Implementierung
				die("Provider-Modul konnte nicht geladen werden.");
				break;
		}
	}

	function Serverstring($strServer,$line)
	{
		return "Registrar:</TD><TD><input type=\"text\" id=\"user_host$line\" value=\"$strServer\"";
	}

	function PostToHost($host, $path, $referer, $data_to_send,$user="",$pass="") {
		//von php-faq.de
		$fp = fsockopen($host, 80);
		fputs($fp, "POST $path HTTP/1.1\r\n");
		fputs($fp, "Host: $host\r\n");
	    
		if ($user!="")
			fputs($fp, "Authorization: Basic ".base64_encode($user.":".$pass)."\r\n");
		fputs($fp, "Referer: $referer\r\n");
		fputs($fp, "Content-type: application/x-www-form-urlencoded\r\n");
		fputs($fp, "Content-length: ". strlen($data_to_send) ."\r\n");
		fputs($fp, "Connection: close\r\n\r\n");
		fputs($fp, $data_to_send);
		while(!feof($fp)) {
		    $res .= fgets($fp, 128);
		}
		fclose($fp);
		return $res;
	}

	function GetFromHost($host, $path, $referer, $cookies_to_send,$user="",$pass="") {
		//von php-faq.de
		$fp = fsockopen($host, 80);
		fputs($fp, "GET $path HTTP/1.1\r\n");
		fputs($fp, "Host: $host\r\n");
		if ($cookies_to_send!="")
			fputs($fp,"Cookie: $cookies_to_send\r\n");

		if ($user!="")
			fputs($fp, "Authorization: Basic ".base64_encode($user.":".$pass)."\r\n");
		fputs($fp, "Referer: $referer\r\n");
		fputs($fp, "Connection: close\r\n\r\n");
		
		while(!feof($fp)) {
		    $res .= fgets($fp, 128);
		}
		fclose($fp);
		return $res;
	}

	function GetFromHostSSL($host, $path, $referer, $cookies="") {
		//von php-faq.de
		$fp = fsockopen('ssl://' . $host, 443, $errno, $errmessage);
		fputs($fp, "GET $path HTTP/1.1\r\n");
		fputs($fp, "Host: $host\r\n");
		if ($cookies!="")
			fputs($fp,"Cookie: $cookies\r\n");
		fputs($fp, "Referer: $referer\r\n");
		fputs($fp, "Content-type: application/x-www-form-urlencoded\r\n");
		fputs($fp, "Content-length: ". strlen($data_to_send) ."\r\n");
		fputs($fp, "Connection: close\r\n\r\n");
		//fputs($fp, $data_to_send);
		while(!feof($fp)) {
		    $res .= fgets($fp, 128);
		}
		fclose($fp);
		return $res;
	}

	function postToHostSSL ($server, $port, $path, $data) {
   		$fp = fsockopen('ssl://' . $server, $port, $errno, $errmessage);
   		if (!$fp) {
	     	echo "Error $errmessage ($errno)<br>\n";
    	 	return FALSE;
   		}
   		else {
     		fputs($fp, "POST $path HTTP/1.1\r\n");
     		fputs($fp, "Host: $server\r\n");
     		fputs($fp, "Content-Type: application/x-www-form-urlencoded\r\n");
     		fputs($fp, "Content-Length: " . strlen($data) . "\r\n");
     		fputs($fp, "Connection: close\r\n");
     		fputs($fp, "\r\n");
     		fputs($fp, $data);
     		$content = '';
     		while (!feof($fp)) {
       			$content .= fgets($fp, 128);
     		}
     	fclose($fp);
     	return $content;
   		}

	}

	function updateSnomBalance($server,$balance,$msg=false)
	{
		$this->debug("Verbinde mit Telefon...");
		//Wir wissen zwar, welcher Provider gemeint ist, aber nicht, auf welche
		//Leitung im Snom dieser Provider programmiert wurde. Also alle Leitungen
		//durchlaufen und nach der richtigen suchen.
		for($i=1;$i<=7;$i++)
        {
			$buffer="";
			if($this->SnomUser!="")
				$auth=$this->SnomUser.":".$this->SnomPass."@";
			else
				$auth="";
			$handle = fopen("http://$auth".$this->SnomIP."/line_login.htm?l=$i","r");
			if($handle)
			{
				while (!feof($handle)) {
 					$buffer .= fgets($handle, 4096);
				}
			}

			if(strpos($buffer,$this->Serverstring($server,$i)))
            {
				//richtige Leitung gefunden
				$this->debug("Verbindung zum Telefon OK");
				//Das Formular auslesen
				$search = "/id=\\\"user_realname".$i."\\\" value=\\\"(.*)\\\" n/";
				preg_match($search,$buffer,$treffer);
				$user_realname = $treffer[1];

				$search = "/id=\\\"user_name".$i."\\\" value=\\\"(.*)\\\" n/";
				preg_match($search,$buffer,$treffer);
				$user_name =$treffer[1];

				$search = "/id=\\\"user_pass".$i."\\\" value=\\\"(.*)\\\" n/";
				preg_match($search,$buffer,$treffer);
				$user_pass =$treffer[1];

				$search = "/id=\\\"user_host".$i."\\\" value=\\\"(.*)\\\" n/";
				preg_match($search,$buffer,$treffer);
				$user_host =$treffer[1];

				$search = "/id=\\\"user_pname".$i."\\\" value=\\\"(.*)\\\" n/";
				preg_match($search,$buffer,$treffer);
				$user_pname =$treffer[1];

				$search = "/id=\\\"user_mailbox".$i."\\\" value=\\\"(.*)\\\" n/";
				preg_match($search,$buffer,$treffer);
				$user_mailbox =$treffer[1];

				$search = "/value=\\\"(.*)\\\" selected/";
				preg_match($search,$buffer,$treffer);
				$user_ringer =$treffer[1];

				$search = "/id=\\\"user_custom".$i."\\\" value=\\\"(.*)\\\" n/";
				preg_match($search,$buffer,$treffer);
				$user_custom =$treffer[1];

				$search = "/id=\\\"user_idle_text".$i."\\\" value=\\\"(.*)\\\" n/";
				preg_match($search,$buffer,$treffer);
				$user_idle_text =$treffer[1];
				if($msg)
					$this->idletext[$i]=$user_idle_text;
				print_r($this->idletext);
				//und das Formular wieder abschicken
				$data = "user_realname$i=".urlencode($user_realname);
				$data.="&"."user_name$i=".urlencode($user_name);
                $data.="&"."user_pass$i=".urlencode($user_pass);
                $data.="&"."user_host$i=".urlencode($user_host);
                $data.="&"."user_pname$i=".urlencode($user_pname);
                $data.="&"."user_mailbox$i=".urlencode($user_mailbox);
                $data.="&"."user_ringer$i=".urlencode($user_ringer);
                $data.="&"."user_custom$i=".urlencode($user_custom);
				if (is_array($balance))
                {   $data.="&"."user_idle_text$i=".urlencode($balance[$i]);}
				else
					$data.="&"."user_idle_text$i=".urlencode($balance);
                $data.="&"."Settings=Speichern";
				echo $data;
				 if($this->SnomUser!="")
				{	$user =$this->SnomUser;
					$pass =$this->SnomPass;
				}
				$this->debug("Schreibe neuen Text: ".(is_array($balance))?$balance[i]:$balance);
				$this->PostToHost(
				              $this->SnomIP,
				              "/line_login.htm?l=$i",
				              $this->SnomIP,
				              $data, $user, $pass
				);

			}
		}
		
		
	}

	function update($provider="")
    {
		if($provider=="")
        {   //Alle Provider updaten

			foreach($this->arrProviders as $myprovider)
            {
				$this->update($myprovider);
   			}
			return true;
		}else{
			//nur den angegebenen Provider updaten
			if(class_exists($provider))
            {
				$myprovider = new $provider;
				$server = $myprovider->getServer();
				$this->updateSnomBalance($server,"update!",true);
				$new_balance = $myprovider->getBalance($this);
				$this->updateSnomBalance($server,"E ".$new_balance);
				sleep($this->waitfor);
				if(method_exists($myprovider,'getDefaultText'))
					$this->updateSnomBalance($server,$myprovider->getDefaultText());
				else
					$this->updateSnomBalance($server,$this->idletext);
			}else{
				$this->error(2);
			}
		}
	}
	function debug($msg)
	{
		echo $msg."<br>";
		flush();
	}
	function doEvents()
    {
		switch($_GET['action'])
        {
			case "update":
				if($this->SnomIP=="")
				{	if($this->detectIP())
						if(isset($_GET['provider']))
                   		{
							$this->update($_GET['provider']);
						}else{
    	                    $this->update();
						}
					else
						$this->error(1);
                }else
                {
					$this->debug("IP des Telefons: ".$this->SnomIP);
					if(isset($_GET['provider']))
                    {
						$this->update($_GET['provider']);
					}else{
                        $this->update();
					}
					
				}
				break;
			case "save":
				if(isset($_GET['ip']) && $this->useDB)
                {
					$setting = new settings;
					$setting->LoadByKey('snom_ip');
					$setting->Setvalue($_GET['ip']);
					$setting->Save();
					$this->SnomIP = $setting->Getvalue();
				}
			default:
				if($this->useDB)
					$this->showSettings();
				else
					echo "Datenbank ist deaktiviert. Setze useDB = true zum aktivieren.";
		}

	}
}
$page = new Snom;
$page->doEvents();
?>
